package net.moonleay.mods.gimble.mixin;

import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.nbt.NbtCompound;
import net.minecraft.network.Packet;
import net.minecraft.world.World;
import net.minecraft.world.entity.EntityLike;
import net.moonleay.mods.gimble.client.editor.ClientEditor;
import net.moonleay.mods.gimble.client.editor.modes.ModeModifier;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(Entity.class)
public class NoClipMixin {

    @Shadow public boolean noClip;

    @Inject(method = "tick", at = @At(value = "HEAD"))
    private void enoClip(CallbackInfo ci) {
        if (!ClientEditor.INSTANCE.containsModifier(ModeModifier.NO_CLIP))
            return;

        // TODO: Add player check, add multiplayer compat
        if(!((Entity)(Object)this instanceof PlayerEntity))
            return;

        this.noClip = true;
    }
}
